package com.bzd.web.controller.yxgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.yxgl.SYxglCzkCzkxfTransactionrecordService;

import java.util.List;

/**
*
* 储值卡交易记录表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "yxgl/syxglczkczkxftransactionrecord")
public class SYxglCzkCzkxfTransactionrecordController extends BaseController {

    // 页面跳转前缀
    private String prefix = "yxgl";

    @Autowired
    private SYxglCzkCzkxfTransactionrecordService sYxglCzkCzkxfTransactionrecordService;

    /**
    * 储值卡交易记录表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("yxgl:yx:view")
    @GetMapping("/sYxglCzkCzkxfTransactionrecordAdd")
    public String add() {
        return prefix + "/SYxglCzkCzkxfTransactionrecordAdd";
    }

    /**
    * 储值卡交易记录表 新增
    *
    * @return
    */
    @Log(title = "储值卡交易记录表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sYxglCzkCzkxfTransactionrecordAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sYxglCzkCzkxfTransactionrecordService.addSYxglCzkCzkxfTransactionrecord(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 储值卡交易记录表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("yxgl:yx:view")
    @GetMapping("/sYxglCzkCzkxfTransactionrecordView")
    public String syxglczkczkxftransactionrecordListView() {
        return prefix + "/SYxglCzkCzkxfTransactionrecordList";
    }

    /**
    * 储值卡交易记录表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("yxgl:yx:sYxglCzkCzkxfTransactionrecordList")
    @PostMapping("/sYxglCzkCzkxfTransactionrecordList")
    @ResponseBody
    public TableDataInfo syxglczkczkxftransactionrecordList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sYxglCzkCzkxfTransactionrecordService.findSYxglCzkCzkxfTransactionrecordList(pd);
        return getDataTable(pageData);
    }

    /**
    * 储值卡交易记录表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("yxgl:yx:remove")
    @Log(title = "储值卡交易记录表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sYxglCzkCzkxfTransactionrecordRemove")
    @ResponseBody
    public AjaxResult syxglczkczkxftransactionrecordRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sYxglCzkCzkxfTransactionrecordService.SYxglCzkCzkxfTransactionrecordRemove(pd);
        return toAjax(integer);
    }

    /**
    * 储值卡交易记录表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("yxgl:yx:edit")
    @GetMapping("/sYxglCzkCzkxfTransactionrecordEdit/{id}")
    public String syxglczkczkxftransactionrecordView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sYxglCzkCzkxfTransactionrecordService.findSYxglCzkCzkxfTransactionrecordList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/syxglczkczkxftransactionrecordPageEdit";
        }
        return prefix+ "/syxglczkczkxftransactionrecordEdit";
    }

    /**
    * 储值卡交易记录表保存修改的数据
    */
    @RequiresPermissions("yxgl:yx:edit")
    @Log(title = "储值卡交易记录表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sYxglCzkCzkxfTransactionrecordEdit")
    @ResponseBody
    public AjaxResult syxglczkczkxftransactionrecordEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sYxglCzkCzkxfTransactionrecordService.updateSYxglCzkCzkxfTransactionrecord(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表syxglczkczkxftransactionrecord with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表syxglczkczkxftransactionrecord with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
